#!/usr/bin/python3

'''
Double-check of 8-bit Galois LFSR with 4 taps at 0xC3.
'''

# x is an 8-tuple of ones and zeros.
def succ(x):
    a, b, c, d, e, f, g, h = x
    return h, h^a, b, c, d, e, h^f, h^g

# x is an 8-tuple of ones and zeros.
def pred(x):
    A,   B, C, D, E, F,   G,   H = x
#   h, h^a, b, c, d, e, h^f, h^g = x
#   return   a, b, c, d, e,   f,   g
    return A^B, C, D, E, F, A^G, A^H, A

def pred_succ_check():
    for i in range(256):
        x = tuple(map(int, bin(2**64 + i)[-8:]))
        if x != pred(succ(x)):
            print('bad', x, succ(x), pred(succ(x)))

def period_check():
    orig = 0, 0, 0, 0, 0, 0, 0, 1
    now = orig
    count = 0
    while True:
        now = succ(now)
        count = 1 + count
        if now == orig:
            break
    print('period is', count)

pred_succ_check()
period_check()
