#!/usr/bin/python3

'''
Convert SRAM CPU assembler source files into C representation for linkage.
This is done with every file with a name ending in ".at", and the root
name will be prefixed by "asmtest_" for the string in C.
'''

from os import chdir, listdir

# Here are the substitutions to escape into C.
subs = ('\\', '\\\\'), ('\n', '\\n'), ('\t', '\\t'), ('"', '\\"')

of = open('asm-tests.c', 'w')
print("// automatically generated by gen-asm-tests.py", file = of)

chdir('asm-tests')
for name in listdir():
    if not name.endswith('.at'):
        continue
    cName = 'asmtest_' + name[:-3]
    print('    building', cName);
    text = open(name).read()
    for x, y in subs:
        text = text.replace(x, y)
    print('\nstatic char *%s = "%s";' % (cName, text), file = of)

of.close()
